diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/Makefile head/tools/vps/autobuild/Makefile
--- clean-head/tools/vps/autobuild/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/Makefile	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,246 @@
+#
+# Klaus P. Ohrhallinger <k@7he.at>, 2012-2013
+# 
+# $Id: Makefile 128 2013-04-09 18:07:32Z klaus $
+#
+
+FREEBSD_VERSION=91
+ORIGSRCURL=ftp://ftp.at.freebsd.org/pub/FreeBSD/releases/amd64/9.1-RELEASE/src.txz
+SVNURL='svn+ssh://klaus@svn.7he.at/svn/vps/trunk'
+
+BUILDER32_HOST=builder32.7he.at
+BUILDER32_USER=root
+
+SOURCES=usr/src/sys usr/src/sbin/mount usr/src/include
+
+DIFF_EXCLUDE=".svn\nrsync_vps.amd64\nrsync_vps.i386\nautobuild\n\*nodiff\n"
+
+#
+#
+#
+
+# debug
+COPTFLAGS= -pipe
+CFLAGS= -fno-strict-aliasing -pipe
+
+# prod
+#COPTFLAGS= -pipe -O2
+#CFLAGS= -fno-strict-aliasing -pipe -O2
+
+
+all:	fetch extract diff patch build summary
+#all:	build summary
+
+build:	build_amd64_dbg build_amd64_prod build_i386_dbg build_i386_prod
+#build:	build_amd64_dbg build_i386_dbg
+#build:	build_amd64_prod build_i386_prod
+#build:	build_amd64_dbg
+#build:	build_i386_dbg
+
+clean:
+	rm -rf work
+
+fetch: fetch_orig fetch_vps
+
+extract: extract_pre extract_orig extract_vps
+
+fetch_orig:
+	if [ ! -s "src.txz" ] \
+	; then \
+		fetch -4 ${ORIGSRCURL} \
+	; else \
+		echo "source already downloaded" \
+	; fi
+
+fetch_vps:
+	if [ ! -d "trunk" ] \
+	; then \
+		svn co ${SVNURL} \
+	; else \
+		echo "svn already checked out" \
+	; fi
+
+extract_pre:
+	mkdir work
+
+extract_orig:
+	mkdir work/orig
+	tar xJpf src.txz -C work/orig ${SOURCES}
+	mv work/orig/usr/src/* work/orig/
+	rm -r work/orig/usr
+
+extract_vps:
+	cp -a trunk work
+	rm -rf work/trunk/web
+
+diff:
+	svn info trunk | grep Revision | awk '{print $$2}' > ./work/svnversion
+	[ -e "vps.diff" ] && rm vps.diff || true
+	printf ${DIFF_EXCLUDE} > ./work/diffexclude
+	# diff: 0 -> equal; 1 -> different; 2 -> trouble
+	(cd work; diff -Naupr -X ./diffexclude -I '$$Id.*$$' -I '$$FreeBSD.*$$' -w orig trunk \
+		> ../vps-fbsd${FREEBSD_VERSION}-r`cat ./svnversion`.diff) || true
+	ls -lh vps-fbsd${FREEBSD_VERSION}-r`cat ./work/svnversion`.diff
+	ln -s vps-fbsd${FREEBSD_VERSION}-r`cat ./work/svnversion`.diff vps.diff
+	rm ./work/diffexclude
+
+patch:
+	[ -d "work/build" ] && rm -rf work/build || true
+	cp -a work/orig work/build
+	(cd work/build/; patch -p1 < ../../vps.diff)
+	cp -v work/trunk/tools/vps/rsync/rsync_vps.amd64 \
+		work/build/tools/vps/rsync/rsync_vps.amd64
+	cp -v work/trunk/tools/vps/rsync/rsync_vps.i386 \
+		work/build/tools/vps/rsync/rsync_vps.i386
+
+summary:
+	ls -lh vps*.diff
+	ls -lh work/build/vps*.tbz
+
+build_amd64_dbg:
+	printf "COPTFLAGS= -pipe\nCFLAGS= -fno-strict-aliasing -pipe\n" > \
+		/tmp/make-dbg.conf
+	(cd work/build/sys/amd64/conf && \
+		config VPS_DBG)
+	(cd work/build/sys/amd64/compile/VPS_DBG && \
+		make cleandepend __MAKE_CONF=/tmp/make-dbg.conf && \
+		make depend __MAKE_CONF=/tmp/make-dbg.conf && \
+		make kernel __MAKE_CONF=/tmp/make-dbg.conf && \
+		make modules __MAKE_CONF=/tmp/make-dbg.conf)
+	make do-package \
+		COMPILEDIR=work/build/sys/amd64/compile/VPS_DBG \
+		ARCH2=amd64 \
+		TYPE2=dbg \
+		MAKE_CONF=/tmp/make-dbg.conf
+	
+build_amd64_prod:
+	printf "COPTFLAGS= -pipe -O2\nCFLAGS= -fno-strict-aliasing -pipe -O2 -Wuninitialized\n" > \
+		./work/make-prod.conf
+	(cd work/build/sys/amd64/conf && \
+		config VPS_PROD)
+	(cd work/build/sys/amd64/compile/VPS_PROD && \
+		make cleandepend __MAKE_CONF=./work/make-prod.conf && \
+		make depend __MAKE_CONF=./work/make-prod.conf && \
+		make kernel __MAKE_CONF=./work/make-prod.conf && \
+		make modules __MAKE_CONF=./work/make-prod.conf)
+	make do-package \
+		COMPILEDIR=work/build/sys/amd64/compile/VPS_PROD \
+		ARCH2=amd64 \
+		TYPE2=prod \
+		MAKE_CONF=/tmp/make-prod.conf
+
+build_i386_dbg:
+	#[ ! -d "${BUILDER32}/tmp/work" ]
+	cp Makefile ./work/Makefile
+	rm -rf ./work/pkg-files
+	cp -a pkg-files ./work/pkg-files
+	rsync -av --delete -e "ssh -4 -l ${BUILDER32_USER}" work ${BUILDER32_HOST}:/tmp/${BUILDER32_USER}/
+	ssh -4 -l ${BUILDER32_USER} ${BUILDER32_HOST} "cd /tmp/${BUILDER32_USER} && make -f work/Makefile __build_i386_dbg"
+	rsync -av --delete -e "ssh -4 -l ${BUILDER32_USER}" ${BUILDER32_HOST}:/tmp/${BUILDER32_USER}/work ./
+
+
+__build_i386_dbg:
+	printf "COPTFLAGS= -pipe\nCFLAGS= -fno-strict-aliasing -pipe\n" > \
+		/tmp/${BUILDER32_USER}/make-dbg.conf
+	(cd work/build/sys/i386/conf && \
+		config VPS_DBG)
+	(cd work/build/sys/i386/compile/VPS_DBG && \
+		make cleandepend __MAKE_CONF=/tmp/make-dbg.conf && \
+		make depend __MAKE_CONF=/tmp/make-dbg.conf && \
+		make kernel __MAKE_CONF=/tmp/make-dbg.conf && \
+		make modules __MAKE_CONF=/tmp/make-dbg.conf )
+	rm -rf ./pkg-files
+	mv work/pkg-files ./pkg-files
+	make -f work/Makefile do-package \
+		COMPILEDIR=work/build/sys/i386/compile/VPS_DBG \
+		ARCH2=i386 \
+		TYPE2=dbg \
+		MAKE_CONF=/tmp/${BUILDER32_USER}/make-dbg.conf
+	rm -rf ./pkg-files
+	
+build_i386_prod:
+	#[ ! -d "${BUILDER32}/tmp/work" ]
+	cp Makefile ./work/Makefile
+	rm -rf ./work/pkg-files
+	cp -a pkg-files ./work/pkg-files
+	rsync -av --delete -e "ssh -4 -l ${BUILDER32_USER}" work ${BUILDER32_HOST}:/tmp/${BUILDER32_USER}/
+	ssh -4 -l ${BUILDER32_USER} ${BUILDER32_HOST} "cd /tmp/${BUILDER32_USER} && make -f work/Makefile __build_i386_prod"
+	rsync -av --delete -e "ssh -4 -l ${BUILDER32_USER}" ${BUILDER32_HOST}:/tmp/${BUILDER32_USER}/work ./
+
+
+__build_i386_prod:
+	printf "COPTFLAGS= -pipe -O2\nCFLAGS= -fno-strict-aliasing -pipe -O2 -Wuninitialized\n" > \
+		/tmp/make-prod.conf
+	(cd work/build/sys/i386/conf && \
+		config VPS_PROD)
+	(cd work/build/sys/i386/compile/VPS_PROD && \
+		make cleandepend __MAKE_CONF=/tmp/make-prod.conf && \
+		make depend __MAKE_CONF=/tmp/make-prod.conf && \
+		make kernel __MAKE_CONF=/tmp/make-prod.conf && \
+		make modules __MAKE_CONF=/tmp/make-prod.conf )
+	rm -rf ./pkg-files
+	mv work/pkg-files ./pkg-files
+	make -f work/Makefile do-package \
+		COMPILEDIR=work/build/sys/i386/compile/VPS_PROD \
+		ARCH2=i386 \
+		TYPE2=prod \
+		MAKE_CONF=/tmp/make-prod.conf
+	rm -rf ./pkg-files
+
+do-package:
+	mkdir "${COMPILEDIR}/dist"
+	(cd ${COMPILEDIR} && make install DESTDIR=`pwd`/dist)
+	mkdir -p ${COMPILEDIR}/dist/sbin
+	mkdir -p ${COMPILEDIR}/dist/usr/sbin
+	mkdir -p ${COMPILEDIR}/dist/usr/share/man/man4
+	mkdir -p ${COMPILEDIR}/dist/usr/share/man/man5
+	mkdir -p ${COMPILEDIR}/dist/usr/share/man/man8
+	mkdir -p ${COMPILEDIR}/dist/usr/share/man/man9
+	mkdir -p ${COMPILEDIR}/dist/etc/vps
+	(DIR=`realpath ${COMPILEDIR}`; \
+		cd ${COMPILEDIR}/../../../../usr.sbin/vpsctl && \
+		make clean __MAKE_CONF=${MAKE_CONF} && \
+		make __MAKE_CONF=${MAKE_CONF} && \
+		make install DESTDIR=$${DIR}/dist __MAKE_CONF=${MAKE_CONF} && \
+		make clean __MAKE_CONF=${MAKE_CONF} )
+	(DIR=`realpath ${COMPILEDIR}`; \
+		cd ${COMPILEDIR}/../../../../sbin/mount_vpsfs && \
+		make clean __MAKE_CONF=${MAKE_CONF} && \
+		make __MAKE_CONF=${MAKE_CONF} && \
+		make install DESTDIR=$${DIR}/dist __MAKE_CONF=${MAKE_CONF} && \
+		make clean __MAKE_CONF=${MAKE_CONF} )
+	install -o root -g wheel -m 0555 \
+		${COMPILEDIR}/../../../../tools/vps/rsync/rsync_vps.${ARCH2} \
+		${COMPILEDIR}/dist/usr/sbin/rsync_vps
+	# various other files that go into package
+	install -o root -g wheel -m 0644 \
+		pkg-files/dist/etc_vps_example.conf \
+		${COMPILEDIR}/dist/etc/vps/vps_example.conf
+	install -o root -g wheel -m 0755 \
+		pkg-files/dist/vpssetup.sh \
+		${COMPILEDIR}/dist/etc/rc.vpssetup.sh
+	# all installed now
+	echo "@cwd /" > ${COMPILEDIR}/pkg-plist
+	echo "@comment ORIGIN:misc/vps" >> ${COMPILEDIR}/pkg-plist
+	echo "@srcdir `realpath ${COMPILEDIR}/dist`" >> ${COMPILEDIR}/pkg-plist
+	echo "@exec mkdir -p /etc/vps" >> ${COMPILEDIR}/pkg-plist
+	echo "@exec mkdir -p /usr/vps" >> ${COMPILEDIR}/pkg-plist
+	(cd ${COMPILEDIR}/dist && find . -type f >> ../pkg-plist)
+	echo "@dirrm /etc/vps" >> ${COMPILEDIR}/pkg-plist
+	echo "@dirrm /usr/vps" >> ${COMPILEDIR}/pkg-plist
+	pkg_create -v \
+		-D pkg-files/pkg-message \
+		-c pkg-files/pkg-comment \
+		-d pkg-files/pkg-descr \
+		-i pkg-files/pkg_install_pre.sh \
+		-I pkg-files/pkg_install_post.sh \
+		-k pkg-files/pkg_remove_pre.sh \
+		-K pkg-files/pkg_remove_post.sh \
+		-f ${COMPILEDIR}/pkg-plist \
+		work/build/vps-fbsd${FREEBSD_VERSION}-r`cat ./work/svnversion`-${ARCH2}-${TYPE2}.tbz
+
+	# clean up
+	rm -rf "${COMPILEDIR}/dist"
+	rm -f ${COMPILEDIR}/pkg-plist
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg-comment head/tools/vps/autobuild/pkg-files/pkg-comment
--- clean-head/tools/vps/autobuild/pkg-files/pkg-comment	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg-comment	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1 @@
+VPS - OS Level Virtualization
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg-descr head/tools/vps/autobuild/pkg-files/pkg-descr
--- clean-head/tools/vps/autobuild/pkg-files/pkg-descr	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg-descr	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,7 @@
+OS Level Virtualization
+See vps(4) for more information.
+
+This package will backup your previously installed
+kernel to /boot/kernel.GENERIC upon install.
+
+WWW: http://www.7he.at/freebsd/vps/
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg-message head/tools/vps/autobuild/pkg-files/pkg-message
--- clean-head/tools/vps/autobuild/pkg-files/pkg-message	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg-message	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,16 @@
+* * * * * * * * * * * * * * * * * * * * * * * * * *
+Your previously installed kernel has been moved to
+/boot/kernel.GENERIC
+
+Type:
+boot /boot/kernel.GENERIC/kernel
+at the boot loader prompt to use it.
+
+There is an example config file at 
+/etc/vps/vps_example.conf
+
+A script that loads the kernel modules is at
+/etc/rc.vpssetup.sh
+
+See vpsctl(8) how to get started. 
+* * * * * * * * * * * * * * * * * * * * * * * * * *
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg_install_post.sh head/tools/vps/autobuild/pkg-files/pkg_install_post.sh
--- clean-head/tools/vps/autobuild/pkg-files/pkg_install_post.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg_install_post.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+exit 0
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg_install_pre.sh head/tools/vps/autobuild/pkg-files/pkg_install_pre.sh
--- clean-head/tools/vps/autobuild/pkg-files/pkg_install_pre.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg_install_pre.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+if [ ! -d /boot/kernel.GENERIC ]
+then
+        mv /boot/kernel /boot/kernel.GENERIC
+        echo "Moved currently installed kernel to /boot/kernel.GENERIC"
+fi
+
+exit 0
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg_remove_post.sh head/tools/vps/autobuild/pkg-files/pkg_remove_post.sh
--- clean-head/tools/vps/autobuild/pkg-files/pkg_remove_post.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg_remove_post.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+if [ -d /boot/kernel.GENERIC ]
+then
+        rmdir /boot/kernel
+        mv /boot/kernel.GENERIC /boot/kernel
+fi
+
+exit 0
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autobuild/pkg-files/pkg_remove_pre.sh head/tools/vps/autobuild/pkg-files/pkg_remove_pre.sh
--- clean-head/tools/vps/autobuild/pkg-files/pkg_remove_pre.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autobuild/pkg-files/pkg_remove_pre.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+exit 0
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/autoinstalldist.sh head/tools/vps/autoinstalldist.sh
--- clean-head/tools/vps/autoinstalldist.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/autoinstalldist.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,17 @@
+#!/bin/sh
+
+fail() {
+        echo "FAILURE"
+        exit 1
+}
+
+tar xzpf dist.tgz || fail
+rm -rf /boot/kernel || fail
+mv boot/kernel /boot/ || fail
+mv usr/sbin/vpsctl /usr/sbin/vpsctl || fail
+mv sbin/mount_vpsfs /sbin/mount_vpsfs || fail
+
+echo "SUCCESS"
+exit 0
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/builddist.sh head/tools/vps/builddist.sh
--- clean-head/tools/vps/builddist.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/builddist.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,31 @@
+#!/bin/sh -x
+
+# to be run in kernel compile directory
+
+dist="$(pwd)/dist"
+
+rsync_bin="rsync_vps.$(uname -m)"
+
+rm -r ${dist}
+make install DESTDIR=${dist}
+mkdir -p ${dist}/sbin
+mkdir -p ${dist}/usr/sbin
+mkdir -p ${dist}/usr/share/man
+mkdir -p ${dist}/usr/share/man/man4
+mkdir -p ${dist}/usr/share/man/man5
+mkdir -p ${dist}/usr/share/man/man8
+mkdir -p ${dist}/usr/share/man/man9
+cd ../../../../usr.sbin/vpsctl && make clean && make && make install DESTDIR=${dist} && make clean && cd - || exit 1
+cd ../../../../sbin/mount_vpsfs && make clean && make && make install DESTDIR=${dist} && make clean && cd - || exit 1
+cp ../../../../tools/vps/rsync/${rsync_bin} ${dist}/usr/sbin/rsync_vps
+cp ../../../../tools/vps/dist-README ${dist}/README
+
+cd dist
+tar czpvf ../dist.tgz *
+cd ..
+ls -lh dist.tgz
+rm -r ${dist}
+
+exit 0
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/check_linelength.pl head/tools/vps/check_linelength.pl
--- clean-head/tools/vps/check_linelength.pl	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/check_linelength.pl	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,59 @@
+#!/usr/bin/perl -w
+
+use strict;
+
+exit(main(\@ARGV));
+
+sub main {
+	my $line;
+	my $length;
+	my $cpos;
+	my $lpos;
+	my $spacescnt;
+	my $spacesstr;
+	my $argv = shift;
+	my $linenum = 0;
+
+	#print("argv[0]=@$argv[0] argv[1]=@$argv[1]\n");
+
+	open(FILE, "<", @$argv[0]) or die "cannot open [@$argv[0]]";
+
+	while (<FILE>) {
+		$line = $_;
+
+		$linenum += 1;
+
+		# Convert '\t' to '        '.
+		#$line =~ s/\t/        /g;
+		$lpos = 0;
+		while ($line =~ m/\t/) {
+			$cpos = index($line, "\t", $lpos);
+			$spacescnt = 8 - ($cpos % 8);
+			#print("cpos=$cpos spacescnt=$spacescnt\n");
+			$spacesstr = "";
+			while ($spacescnt > 0) {
+				$spacesstr .= " ";
+				$spacescnt -= 1;
+			}
+			$line =~ s/\t/$spacesstr/;
+			$lpos = $cpos;
+		}
+
+		# Remove '\n'.
+		$line =~ s/\n//;
+
+		#print("$line\n");
+
+		$length = length($line);
+
+		if ($length > 76) {
+			print("line $linenum length $length [$line]\n");
+		}
+	}
+
+	close(FILE);
+
+	return (0);
+}
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/dist-README head/tools/vps/dist-README
--- clean-head/tools/vps/dist-README	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/dist-README	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,8 @@
+
+* * * * * * * * * * * * * * * * * * * * * * * * * *
+*       Virtual Private Systems for FreeBSD       *
+* * * * * * * * * * * * * * * * * * * * * * * * * *
+
+Please visit http://www.7he.at/freebsd/vps/
+for further and up to date information.
+
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/installdist.sh head/tools/vps/installdist.sh
--- clean-head/tools/vps/installdist.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/installdist.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,10 @@
+#!/bin/sh -x
+
+tar xzpvf dist.tgz
+rm -rf /boot/kernel
+mv boot/kernel /boot/
+mv usr/sbin/vpsctl /usr/sbin/vpsctl
+mv sbin/mount_vpsfs /sbin/mount_vpsfs
+mv usr/sbin/rsync_vps /usr/sbin/rsync_vps
+
+
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/makepublicdiff.sh head/tools/vps/makepublicdiff.sh
--- clean-head/tools/vps/makepublicdiff.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/makepublicdiff.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+ORIGDIR=clean-head
+WORKDIR=head
+
+DIFFFILENAME=$(date '+vps-%Y%m%d_%s.diff')
+
+diff -Naupr -x .svn -x rsync_vps.\* -I '$Id.*$' -I '$FreeBSD.*$' ${ORIGDIR} ${WORKDIR} > ${DIFFFILENAME} 
+
+ls -lh ${DIFFFILENAME}
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/merge.sh head/tools/vps/merge.sh
--- clean-head/tools/vps/merge.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/merge.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,25 @@
+#!/bin/sh
+
+SRCDIR=trunk
+DSTDIR=head
+
+DIRS=$(cd ${SRCDIR} && find . -type d | grep -v '\.svn')
+FILES=$(cd ${SRCDIR} && find . -type f | grep -v '\.svn')
+
+
+for DIR in ${DIRS}
+do
+	if [ ! -e "${DSTDIR}/${DIR}" ]
+	then
+		mkdir -p "${DSTDIR}/${DIR}"
+	fi
+done
+
+for FILE in ${FILES}
+do
+	cp -av "${SRCDIR}/${FILE}" "${DSTDIR}/${FILE}"
+done 
+
+exit 0
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/rsync/README head/tools/vps/rsync/README
--- clean-head/tools/vps/rsync/README	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/rsync/README	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,4 @@
+
+Binaries are available at:
+XXX
+
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/setup.sh head/tools/vps/setup.sh
--- clean-head/tools/vps/setup.sh	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/setup.sh	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,32 @@
+#!/bin/sh -x
+
+kldload if_vps 
+kldload vps_dev
+kldload vps_ddb
+kldload vps_libdump
+kldload vps_snapst
+kldload vps_restore
+kldload vps_suspend
+kldload vps_account
+kldload vpsfs
+kldload sysvmsg
+kldload sysvsem
+kldload sysvshm
+
+ifconfig vps0 create
+ifconfig vps0 up
+
+sysctl -w net.inet.ip.forwarding=1
+sysctl -w net.inet6.ip6.forwarding=1
+
+sysctl -w debug.vps_core_debug=0
+sysctl -w debug.vps_if_debug=0
+sysctl -w debug.vps_dev_debug=0 
+sysctl -w debug.vps_user_debug=0 
+sysctl -w debug.vps_snapst_debug=0 
+sysctl -w debug.vps_restore_debug=0 
+sysctl -w debug.vps_restore_ktrace=0 
+sysctl -w debug.vps_account_debug=0 
+sysctl -w debug.vps_vpsfs_debug=0
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/tools/vps/splitdiff.pl head/tools/vps/splitdiff.pl
--- clean-head/tools/vps/splitdiff.pl	1970-01-01 01:00:00.000000000 +0100
+++ head/tools/vps/splitdiff.pl	2013-06-24 14:20:19.000000000 +0200
@@ -0,0 +1,33 @@
+#!/usr/bin/perl
+
+use strict;
+
+my $rv = main($ARGV[0], $ARGV[1]);
+
+exit($rv);
+
+sub main
+{
+	my $infile = shift;
+	my $outdir = shift;
+	my $filename;
+
+	open(IN, "<$infile") or die "open error";
+
+	while (<IN>) {
+		if (/^diff (.*) (.*) (.*)/) {
+			close(OUT);
+			$filename = $2;
+			$filename =~ s{/}{_}g;
+			open(OUT, ">$outdir/$filename") or die "open error";
+		}
+		print OUT $_;
+	}
+	close(OUT);
+
+	close(IN);
+
+	return (0);
+}
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/usr.sbin/Makefile head/usr.sbin/Makefile
--- clean-head/usr.sbin/Makefile	2013-06-26 09:47:24.000000000 +0200
+++ head/usr.sbin/Makefile	2013-06-24 14:20:21.000000000 +0200
@@ -90,6 +90,7 @@ SUBDIR=	adduser \
 	tzsetup \
 	ugidfw \
 	vipw \
+	vpsctl \
 	wake \
 	watch \
 	watchdogd \
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/usr.sbin/vpsctl/Makefile head/usr.sbin/vpsctl/Makefile
--- clean-head/usr.sbin/vpsctl/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/usr.sbin/vpsctl/Makefile	2013-06-24 14:20:21.000000000 +0200
@@ -0,0 +1,51 @@
+# $Id: Makefile 162 2013-06-06 18:17:55Z klaus $
+
+PROG=	vpsctl
+MAN=	vpsctl.8 vps.4 vps.9 vps.conf.5
+WARNS?=	6
+BINDIR=	/usr/sbin
+
+CFLAGS+= -I${.CURDIR}/../../sys/ -g
+
+clean:
+	rm -f vpsctl.o priv_ston.o priv_ntos.o vps_libdump.o \
+		vpsctl mkprivlist \
+		priv_ston.c priv_ntos.c \
+		vpsctl.8.gz vps.4.gz vps.9.gz vps.conf.5.gz \
+		vpsctl.8.html vps.conf.5.html vps.4.html vps.9.html mount_vpsfs.8.html \
+		vpsctl.8.ps vps.conf.5.ps vps.4.ps vps.9.ps mount_vpsfs.8.ps \
+		vpsctl.8.pdf vps.conf.5.pdf vps.4.pdf vps.9.pdf mount_vpsfs.8.pdf
+
+mkprivlist:
+	cc -Wall -g -o ./mkprivlist ${.CURDIR}/mkprivlist.c
+
+priv_ston.c priv_ntos.c: mkprivlist
+	./mkprivlist ${.CURDIR}/../../sys/sys/priv.h
+
+vpsctl: priv_ston.c priv_ntos.c
+	cc -Wall -g -I../../sys -I/usr/include -o vpsctl \
+		${.CURDIR}/vpsctl.c \
+		./priv_ston.c \
+		./priv_ntos.c \
+		${.CURDIR}/../../sys/vps/vps_libdump.c
+
+man2:
+	groff -mdoc -Thtml vpsctl.8 > vpsctl.8.html
+	groff -mdoc -Thtml vps.conf.5 > vps.conf.5.html
+	groff -mdoc -Thtml vps.4 > vps.4.html
+	groff -mdoc -Thtml vps.9 > vps.9.html
+	groff -mdoc -Thtml ../../sbin/mount_vpsfs/mount_vpsfs.8 > mount_vpsfs.8.html
+	groff -mdoc -Tps vpsctl.8 > vpsctl.8.ps
+	groff -mdoc -Tps vps.conf.5 > vps.conf.5.ps
+	groff -mdoc -Tps vps.4 > vps.4.ps
+	groff -mdoc -Tps vps.9 > vps.9.ps
+	groff -mdoc -Tps ../../sbin/mount_vpsfs/mount_vpsfs.8 > mount_vpsfs.8.ps
+	ps2pdf vpsctl.8.ps vpsctl.8.pdf
+	ps2pdf vps.conf.5.ps vps.conf.5.pdf
+	ps2pdf vps.4.ps vps.4.pdf
+	ps2pdf vps.9.ps vps.9.pdf
+	ps2pdf mount_vpsfs.8.ps mount_vpsfs.8.pdf
+
+.include <bsd.prog.mk>
+
+# EOF
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/usr.sbin/vpsctl/mkprivlist.c head/usr.sbin/vpsctl/mkprivlist.c
--- clean-head/usr.sbin/vpsctl/mkprivlist.c	1970-01-01 01:00:00.000000000 +0100
+++ head/usr.sbin/vpsctl/mkprivlist.c	2013-06-24 14:20:21.000000000 +0200
@@ -0,0 +1,153 @@
+/*-
+ * Copyright (c) 2009-2013 Klaus P. Ohrhallinger <k@7he.at>
+ * All rights reserved.
+ *
+ * Development of this software was partly funded by:
+ *    TransIP.nl <http://www.transip.nl/>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: mkprivlist.c 133 2013-04-20 17:06:57Z klaus $
+ *
+ */
+
+#include <unistd.h>
+#include <stdlib.h>
+#include <string.h>
+#define _WITH_GETLINE
+#include <stdio.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <regex.h>
+
+int main(int argc, char **argv, char **envp)
+{
+	FILE *fp, *out1, *out2;
+	char *line = NULL;
+	size_t linecap = 0;
+	ssize_t linelen;
+	regex_t expr;
+	regmatch_t results[4];
+	char name[0x100], val[0x100];
+
+	if (argc < 2) {
+		fprintf(stderr, "usage: %s path/to/sys/priv.h\n", argv[0]);
+		return (-1);
+	}
+
+	if ((out1 = fopen("priv_ntos.c", "w")) == NULL) {
+		fprintf(stderr, "fopen(): %s\n", strerror(errno));
+		return (-1);
+	}
+
+	if ((out2 = fopen("priv_ston.c", "w")) == NULL) {
+		fprintf(stderr, "fopen(): %s\n", strerror(errno));
+		return (-1);
+	}
+
+	if ((fp = fopen(argv[1], "r")) == NULL) {
+		fprintf(stderr, "fopen([%s]): %s\n",
+			argv[1], strerror(errno));
+		return (-1);
+	}
+
+	if (regcomp(&expr, "^#define[ \t]+(PRIV_[^ \t]+)[ \t]+([0-9]+)", REG_EXTENDED)) {
+		fprintf(stderr, "regcomp error\n");
+		return (-1);
+	}
+
+	fprintf(out1,
+		"/* AUTOMATICALLY GENERATED FILE */\n"
+		"\n"
+		"#include <sys/priv.h>\n"
+		"\n"
+		"const char * priv_ntos(int priv);\n"
+		"\n"
+		"const char *\n"
+		"priv_ntos(int priv)\n"
+		"{\n"
+		"\n"
+		"    switch (priv) {\n"
+		);
+
+	fprintf(out2,
+		"/* AUTOMATICALLY GENERATED FILE */\n"
+		"\n"
+		"#include <sys/priv.h>\n"
+		"#include <string.h>\n"
+		"\n"
+		"int priv_ston(const char *str);\n"
+		"\n"
+		"int\n"
+		"priv_ston(const char *str)\n"
+		"{\n"
+		"\n"
+		);
+
+	while ((linelen = getline(&line, &linecap, fp)) > 0) {
+		//fwrite(line, linelen, 1, stdout);
+
+		if (regexec(&expr, line, 3, results, 0))
+			continue;
+
+		/*
+		printf("results: [%d/%d] [%d/%d] [%d/%d]\n",
+			results[0].rm_so, results[0].rm_eo,
+			results[1].rm_so, results[1].rm_eo,
+			results[2].rm_so, results[2].rm_eo);
+		*/
+
+		memcpy(name, line + results[1].rm_so, results[1].rm_eo - results[1].rm_so);
+		name[results[1].rm_eo - results[1].rm_so] = '\0';
+
+		memcpy(val, line + results[2].rm_so, results[2].rm_eo - results[2].rm_so);
+		val[results[2].rm_eo - results[2].rm_so] = '\0';
+
+		//printf("name=[%s] val=[%s]\n", name, val);
+
+		fprintf(out1, "    case %s: return (\"%s\");\n",
+			val, name);
+		fprintf(out2, "    if (strcmp(str, \"%s\") == 0) return (%s);\n",
+			name, val);
+	}
+
+	fclose(fp);
+	regfree(&expr);
+
+	fprintf(out2,
+		"    return (0);\n"
+		"}\n"
+		);
+
+	fprintf(out1,
+		"    default: return (\"unknown\");\n"
+		"    }\n"
+		"}\n"
+		);
+
+	fclose(out2);
+	fclose(out1);
+
+	return (0);
+}
+
+/* EOF */
